
var lWarn = {logln:function (o){}}; 
var lInfo = {logln:function (o){}};

var LOGFILE_NAME = "led-wizard.log";
lWarn = new Logger(LOGFILE_NAME);
lInfo = new Logger(LOGFILE_NAME);


function storeSubParameter(path, value) {
    try 
    {
        lInfo.logln("StoreSubParameter Path " + path  + " value " + value + " type " + typeof(value));
        Property.setProperty(path, value);
        Property.setFlag(path, 'ARCHIVE', true);
    }
    catch (e)
    {
        lWarn.logln("Fehler beim StoreSubParameter " + e + " Path " + path  + " value " + value);
    }        
}

var sErrorMSG="";
function setWithRetryOneValue(deviceObj,value,bank,index,iRetry, fFehlertolerant) {
    deviceObj.setConfig(bank,index,value);
    var checkValue=deviceObj.getConfig(bank,index);
    if (fFehlertolerant==null)
        fFehlertolerant=false;
    if (!fFehlertolerant) {
        if (checkValue!=value) {
            if (iRetry>0) {
                lInfo.logln('Fehler: Wert B:'+bank+' ind:'+index+' geschrieben: ' + value + ' gelesen: ' + checkValue + ' noch ' + iRetry + ' Versuche');
                return setWithRetryOneValue(deviceObj,value,bank,index,iRetry-1);
            } else {
                sErrorMSG+='Letzer Versuch: Wert B:'+bank+' ind:'+index+' geschrieben: ' + value + ' gelesen: ' + checkValue ;
                lInfo.logln(sErrorMSG );
                return false;
            }
        } else {
            lInfo.logln('OK : Wert B:'+bank+' ind:'+index+' geschrieben: ' + value + ' gelesen: ' + checkValue);
            return true;
        }
    }
    lInfo.logln('(vielleicht) OK : Wert B:'+bank+' ind:'+index+' geschrieben: ' + value + ' gelesen: ' + checkValue);
    return true;
}

function makeStep(){
	var dsid=Property.getNode('temp/dsid').getValue();
	var array=Property.getNode('temp/value').getValue();
	var step=Property.getNode('temp/step').getValue();
	lInfo.logln("step " + step  + " for  " + dsid);
	var oArray=JSON.parse(array);
	 
	var oDevice=getDevices().byDSID(dsid);
    if (oDevice==null) {
        sErrorMSG='Gert ' + dsid + ' nicht gefunden'
        lWarn.logln(sErrorMSG);
        new Event('led-wizard.step',{detail:'complete',error:true}).raise();
        return;
    }
	
	if (step==oArray.length)
	{
		lInfo.logln('Ende erreicht, schicke complete');
		new Event('led-wizard.step',{detail:'complete',error:false}).raise();
	} else {
		setWithRetryOneValue(oDevice,oArray[step].value,oArray[step].bank,oArray[step].offset,1);
		Property.setProperty('temp/step', step+1);
		lInfo.logln('OK schicke step ' + (step+1));
		new Event('led-wizard.step',{detail:'step','index':step+1}).raise();		
	}
}

function makeComplete(){

	lInfo.logln('ende, bereinige Daten ');
    
	var dsid=Property.getNode('temp/dsid').getValue();
	var id=Property.getNode('temp/catalogeID').getValue();
	
	if (id==-1) {
		Property.getNode('devices').removeNode(dsid);
	} else {
		storeSubParameter('devices/' + dsid + '/dsid' , dsid);
    	storeSubParameter('devices/' + dsid + '/catalogeID' , id);
    	storeSubParameter('devices/' + dsid + '/ts' , ""+(new Date()).getTime());	
	}
	

    Property.store();
    
	Property.getNode('/scripts/led-wizard').removeNode('temp');

}

if (raisedEvent.parameter.detail != null) {
	if (raisedEvent.parameter.detail == 'step') {		
		makeStep();
    }
	if (raisedEvent.parameter.detail == 'complete') {		
		makeComplete();
    }
	if (raisedEvent.parameter.detail == 'prepare') {
		new Event('led-wizard.step',{detail:'step','index':0}).raise();
	}
}

	