
var fActive=false;
var fChangedCallback=[];
var iSubscriptDemo;
var lastUpdate=0;
function changeListener(sValue) {
    
    var oValue=JSON.parse(sValue);
    var fActiveTemp=false;
    if (oValue!=null)
        if (oValue.result!=null)
            if (oValue.result.value!=null) {
                if (oValue.result.value)
                	fActiveTemp=true;
            }
    fActive=fActiveTemp;
	for (var iIndex=0;iIndex<fChangedCallback.length;iIndex++)
		fChangedCallback[iIndex]();
}


function startListener() {
	dss.ajaxAssyncRequestWithoutAnswer('/json/property/getBoolean',{path:'/scripts/led-wizard/demo/state'},changeListener);

	iSubscriptDemo = Math.floor(Math.random() * 100000000000);
	dss.ajaxSyncRequest('/json/event/subscribe', {
	    subscriptionID : iSubscriptDemo,
	    name : 'led-wizard.demo'
	});
	refreshListener();
}

function refreshListener() {
	dss.ajaxAssyncRequestWithoutAnswer('/json/event/get', {
	    subscriptionID : iSubscriptDemo,
	    timeout : 60 * 1000
	}, function(answer) {	
		var result = Ext.JSON.decode(answer);
		if (result.result == null)
			dss.ajaxAssyncRequestWithoutAnswer('/json/property/getBoolean',{path:'/scripts/led-wizard/demo/state'},changeListener);
		else {
			var eItem=result.result.events[result.result.events.length-1];
			fActive=eItem.properties.state=="true";
			for (var iIndex=0;iIndex<fChangedCallback.length;iIndex++)
				fChangedCallback[iIndex]();
		}	
		refreshListener();
	});
}



Ext.define('DSS.addon.Lizard', {

    extend: 'DSS.addon.Framework',

    config: {
        appName: _('LED Wizard'),
        appId: 'led-wizard',
        appVersion: '1.0.0',
        appIcon: 'default_icon.png'
    },

    getHelp: function() {
        return Ext.create('Ext.Component', {
            loader: {
                url: 'locale/' + dss.staticDataModel.activeLanguage + '/help.html',
                autoLoad: true,
                disableCaching: false
            }
        });
    },
    illuminantTypeControl:null,
    myGrid:null,
    setTestButtons: function () {
    	if (this.myGrid==null)
    		return;
        if (fActive) {
        	this.myGrid.btnCustom[0].setDisabled(true);
        	this.myGrid.btnCustom[1].setDisabled(false);
        } else {
        	this.myGrid.btnCustom[0].setDisabled(false);
        	this.myGrid.btnCustom[1].setDisabled(true);
        }
    },
    getContent: function() {
        var me=this;
        illuminantTypeControl= Ext.create('DSS.addon.IlluminantType' ,{});
        illuminantTestControl= Ext.create('DSS.addon.IlluminantTest' ,{});
        
        var oConfig={
                defaultSortCol:'name',
                storeConfig: {
                    storeId : 'lizardStore',
                    fields : [ {name:'id'}, 
                               {name:'dsid', sortType:'asUCText'}, 
                               {name:'catalogeID', sortType:'asUCText'} ]  
                },
                columns: [ {
                    header : _('Device name'),
                    dataIndex : 'dsid',
                    xtype: 'devicenamecolumn', 
                    flex : 3,
                }, {
                    header: _('dsid'),
                    dataIndex: 'dsid',
                    xtype: 'devicedsidcolumn', 
                    width: 200
                }, {
                    header: _('led type'),
                    dataIndex: 'catalogeID',
                    xtype: 'textcolumn', 
                    customColumnRenderer: function (val, metadata, record, rowIdx, colIdx, store, view) {
                        var oRecord=Ext.data.StoreManager.lookup('illuminateTypeStore').findRecord('id',val,0,false,false,true);                        
                        var manuID=oRecord.get('manufactureID');
            			var oVendorRecord=Ext.data.StoreManager.lookup('illuminateVendorStore').findRecord('id',manuID,0,false,false,true);
            			return oVendorRecord.get('vendor') + ' ' + oRecord.get('socket') + ' ' + oRecord.get('name') + ' ' + oRecord.get('watt') + 'W ' + oRecord.get('colortemp');            			               
                    },
                    flex :3
                }, {
                    header: _('modified at'),
                    dataIndex: 'ts',
                    xtype: 'timestampcolumn', 
                    width: 160
                }],     
                buttonText: {
                    newButton: _('New device'),
                    editButton: _('Edit device'),
                    deleteButton: _('Reset device'),
                },
                customButtons:[{
                    text:_('Make a Demo'),
                    iconCls:'icon-demo-start-action',
                    handler:function(grid,entry){
                    	dss.raiseEvent('led-wizard.demo',{actions:'startDemoModus',dsid:entry.get('dsid')});
                       
                    }
                },
                {
                    text:_('Stop Demo'),
                    iconCls:'icon-demo-stop-action',
                    handler:function(grid,entry){
                    	dss.raiseEvent('led-wizard.demo',{actions:'stopDemoModus'});
                    }
                },
                {
                    text:_('Request DB Refresh'),
                    iconCls:'',
                    handler:function(grid,entry){
                        var me = this;
                        var iSubscriptID = Math.floor(Math.random() * 100000000000);
                        dss.ajaxSyncRequest('/json/event/subscribe', {
                            subscriptionID : iSubscriptID,
                            name : 'led-wizard.answer'
                        });
                        dss.raiseEvent('led-wizard.db',{actions:'syncOnline'});
                        dss.ajaxAssyncRequestWithoutAnswer('/json/event/get', {
                            subscriptionID : iSubscriptID,
                            timeout : 60 * 1000
                        }, function() {
                        	refreshIlluminantDB();
                        	dss.ajaxAssyncRequestWithoutAnswer('/json/event/unsubscribe', {
                                subscriptionID : iSubscriptID,
                                name : 'led-wizard.answer'
                            });
                        });
                    }
                }              
                ],
                editorConfig:{
                    title : _('Edit Deviceconfig'),
                    hideSave: true,
                    cancelTitle: _('Close'),
                    staticControls : [ {
                        type: 'hidden',
                        label: 'id',
                        id: 'id'
                    }],
                    tabControls : [{
                        tabLabel : _('Deviceselection'),
                        tabDescription : _('Choose the device, on which the dimmingcurve should be optimized'),
                        content : [{
                               type : 'deviceSelection',
                               id : 'dsid', 
                               filterFunc: function (device) {return (([200,6344,1234,2248,6364].indexOf(device.productID)!=-1)&&(device.outputMode!=0));}, // sdm fehlt
                               specialDeviceRenderer:   function(val, metadata, record, colIdx, store, view) {
                                   var sReturn='<table style="height:16px;"><tr>';
                                   sReturn+='<td><img src="' + record.get('icon') + '" style="margin-right: 5px;"></td>';
                                   sReturn+='<td width="100%">' + record.get('name') + '</td><td>';
                                   sReturn+=dss.staticDataModel.getProductNameForDevice(dss.staticDataModel.getDevice(record.get('dSID')))+'</td>';
                                   if (dss.staticDataModel.getDevice(record.get('dSID')).outputMode==22)
                                		sReturn+='<td style="padding-left:5px;">gedimmt</td>';
                                   else
                                	   sReturn+='<td style="padding-left:5px;">geschaltet</td>';
                                   return sReturn +'</tr></table>';      
                               },
                               flex : true
                          }]
                    }, {
                        tabLabel : _('illuminant'),
                        tabDescription : _('Choose the type of the illuminant'),
                        content : [{
                            type : 'custom',
                            id : 'catalogeID',
                            control: illuminantTypeControl,
                            flex : true
                        }]
                    }, {
                        tabLabel : _('Test'),
                        tabDescription : _('Send the dimmingcurve to the device and test the result'),
                        content : [{
                            type : 'custom',
                            id : 'aaa',
                            control: illuminantTestControl,
                            flex : true
                        }]
                    }]
                },
                listeners: {
                    'loadDataStore':function (grid){
                        me.loadParameter(grid);
                    },
                    'saveEntry':function (grid,values){   
                    	 me.loadParameter(grid);
                    },
                    'deleteEntry':function (grid,entry){
                        dss.raiseEvent('led-wizard',{actions:'resetValue',dsid:entry.get('dsid')});
                        me.loadParameter(grid);
                    },
                }
        };   
        fChangedCallback.push(function () {me.setTestButtons()});
        return Ext.create('DSS.gridPanel', oConfig);
    },   
    loadParameter : function(grid) {    	
    	this.myGrid=grid;
    	oEdit=grid.editorWindow;
    	this.myGrid.btnCustom[0].setVisible(false);
    	this.myGrid.btnCustom[1].setVisible(false);
    	if (oEdit!=null)    
    		if (oEdit.displayBottomText!=null)    			
    			oEdit.displayBottomText.setValue(_('illuminant database updated on: ')+Ext.Date.format(lastUpdate, "d.m.Y H:i"));
        var sString = dss.ajaxSyncRequest('/json/property/query', {
            'query' : '/scripts/led-wizard/devices/*(*)'
        });
        var result = Ext.JSON.decode(sString);
        var oResultObject=dss.parsePropertyQueryAnswer(result,[{name:'dsid',type:'simple'},
                                                               {name:'catalogeID',type:'simple'},
                                                               {name: 'ts',type:'simple'}]);  
        if (oResultObject!=null) {
            grid.loadParameter(oResultObject);
        }
    }
});

Ext.onReady(function() {
    dss.buildUpLang(['locale/{languageSuffix}/led-wizard.po']);
    refreshIlluminantDB();
   
    var ledwizard = Ext.create('DSS.addon.Lizard');
    ledwizard.initPage();
    startListener();
});

function refreshIlluminantDB (){
	 if (Ext.data.StoreManager.lookup('illuminateTypeStore') == null) {
	    Ext.create('Ext.data.Store', {
	        storeId : 'illuminateVendorStore',
	        fields : [ {name:'type', sortType: 'asUCText'},'id','vendorId',{name:'socket', sortType: 'asUCText'},{name:'Eignung'}],
	        proxy : {
	            type : 'memory',
	            reader : {
	                type : 'json',
	                root : 'items'
	            }
	        }
	    });
	    Ext.create('Ext.data.Store', {
	        storeId : 'illuminateTypeStore',
	        fields : [ 'id', {name:'vendor', sortType: 'asUCText'}, 'passive' ],
	        proxy : {
	            type : 'memory',
	            reader : {
	                type : 'json',
	                root : 'items'
	                }
	            }
	        });
	 }
	 Ext.data.StoreManager.lookup('illuminateVendorStore').removeAll();
	 Ext.data.StoreManager.lookup('illuminateTypeStore').removeAll();
	var sString = dss.ajaxSyncRequest('/json/property/getString', {
	    'path' : '/scripts/led-wizard/dbcache'
	});
	var result = Ext.JSON.decode(sString);
	if (result.ok) {
	    var data=[];
	    var vendorArray=[];
	    var objCache=Ext.JSON.decode(result.result.value);
	    for (var iIndex=0;iIndex<objCache.statics.manufacture.length;iIndex++) {
	    	var fAdd=false;
	    	for (var jIndex=0;jIndex<objCache.illuminant.length;jIndex++)
	    		if (objCache.statics.manufacture[iIndex].id==objCache.illuminant[jIndex].manu_id)
	    			fAdd=true;
	    	if (fAdd)
	    		Ext.data.StoreManager.lookup('illuminateVendorStore').add({id:objCache.statics.manufacture[iIndex].id,vendor:objCache.statics.manufacture[iIndex].name});
	    }
	    Ext.data.StoreManager.lookup('illuminateVendorStore').sort('vendor','ASC');
	        
	    for (var iIndex=0;iIndex<objCache.illuminant.length;iIndex++) {
	    	for (var jIndex=0;jIndex<objCache.illuminant[iIndex].curves.length;jIndex++) {
	        	var oItem={
	        			id:objCache.illuminant[iIndex].curves[jIndex].id,
	        			lumen:objCache.illuminant[iIndex].lumen,
	        			ean:objCache.illuminant[iIndex].ean,
	        			colortemp:objCache.illuminant[iIndex].colortemp,
	        			manufactureID:objCache.illuminant[iIndex].manu_id,
	        			watt:objCache.illuminant[iIndex].watt,
	        			name:objCache.illuminant[iIndex].name,
	        			winkel:objCache.illuminant[iIndex].winkel,
	        			dimmMinimum:objCache.illuminant[iIndex].curves[jIndex].dimmMin,
	        			illuminateCount:objCache.illuminant[iIndex].curves[jIndex].illcount,
	        			abilitiy:objCache.illuminant[iIndex].curves[jIndex].dsabi
	        			};
	        	
	        	for (var kIndex=0;kIndex<objCache.statics.mountingForm.length;kIndex++)
	        		if (objCache.statics.mountingForm[kIndex].id==objCache.illuminant[iIndex].mount_id)
	        			oItem.mount=objCache.statics.mountingForm[kIndex].name;
	        	for (var kIndex=0;kIndex<objCache.statics.socket.length;kIndex++)
	        		if (objCache.statics.socket[kIndex].id==objCache.illuminant[iIndex].socket_id)
	        			oItem.socket=objCache.statics.socket[kIndex].name;
	        	for (var kIndex=0;kIndex<objCache.statics.abilityDetail.length;kIndex++)
	        		if (objCache.statics.abilityDetail[kIndex].id==objCache.illuminant[iIndex].curves[jIndex].abidetail)
	        			oItem.abilityDetail=objCache.statics.abilityDetail[kIndex].name;
	        	
	        	oItem.curveValues=[];
	        	for (var kIndex=0;kIndex<objCache.illuminant[iIndex].curves[jIndex].values.length;kIndex++) {
	        		oItem.curveValues.push({id:objCache.illuminant[iIndex].curves[jIndex].values[kIndex].pos,value:objCache.illuminant[iIndex].curves[jIndex].values[kIndex].val});
	        	}
	        	oItem.curveValues.sort(function(a,b){return a.id-b.id;});
	        	for (var kIndex=0;kIndex<oItem.curveValues.length-1;kIndex++) {
	        		if (oItem.curveValues[kIndex].id<=oItem.dimmMinimum)
	        			if (oItem.dimmMinimum<=oItem.curveValues[kIndex+1].id) {
	        				var oTempMinDim=oItem.curveValues[kIndex].value;
	        				oItem.dimmMinimumPos=oTempMinDim;
	        				oItem.dimmMinimum=Math.round(oTempMinDim/100);	        				
	        				kIndex=oItem.curveValues.length;	        				
	        			}
	        	}
	        	if (oItem.illuminateCount==1)
	        		Ext.data.StoreManager.lookup('illuminateTypeStore').add(oItem);
	        }
	    }
	    Ext.data.StoreManager.lookup('illuminateTypeStore').sort('socket','ASC');
		var sString = dss.ajaxSyncRequest('/json/property/getString', {
		    'path' : '/scripts/led-wizard/dbrefresh'
		});
		var result = Ext.JSON.decode(sString);
		if (result.ok) {
			lastUpdate=new Date();
			lastUpdate.setTime(parseInt(result.result.value,10));
	    	if (oEdit!=null)    
	    		if (oEdit.displayBottomText!=null)    			
	    			oEdit.displayBottomText.setValue(_('illuminant database updated on: ')+Ext.Date.format(lastUpdate, "d.m.Y H:i"));
		}
		
	}
}

var oEdit=null;